; BYTEFIX.ASM -- change a hex byte in a binary file
;
; rugxulo _AT_ gmail
;
; public domain, free for any use, nenies proprajho, "Christus Rex!"

cpu 8086

ARGC equ 80h
ARGV equ 81h
BYTE1 equ ARGV+1+8+1
CR equ 13
FILENAME equ ARGV+1+8+1+2+1+2+1
LF equ 10
MINARGC equ 15+1

CLOSEFILE equ 3Eh
GOODBYE equ 4Ch
OPENFILERW equ 3D02h
READFILE equ 3Fh
SEEKSETFILE equ 4200h
WRITEFILE equ 40h
WRITESTR equ 9

%idefine DOS int 21h

%idefine b byte
%idefine w word

%macro proc 1
%1:
%endm

%macro endp 0
.ret:
  ret
%endm

%macro charargs 0
  push w[BYTE1+3]
  push w[BYTE1]
  mov di,charbyte1
%rep 2
  pop ax
  stosw
%endrep
%endm

%macro stripblanks 0
  mov di,ARGV
  lea si,[di+1]
  inc cx
  mov al,' '
  rep scasb
  dec di
  mov [ARGC],cl
  xchg si,di
  push cx
  push cx
  rep movsb
  pop cx
  pop di
  add di,ARGV
  mov al,' '
  std
  rep scasb
  cld
  inc cx
  mov b[di+2],0 ; NUL (for ASCIIZ filename)
  mov [ARGC],cl
%endm

%macro fixargs 0
  xor ch,ch
  mov cl,[ARGC]
  jcxz %%bye
  push cx
  stripblanks
  pop cx
  mov si,ARGV+1
  mov di,si
%%loop:
  lodsb
  push cx
  mov bx,'az'
  push bx
  call rangecheck
  pop cx
  sbb bl,bl
  or bl,~' '
  and al,bl
  stosb
  loop %%loop
%%bye:
%endm

%macro scanofs 0
  mov cx,8
%%load:
  lodsb
  push cx
  call ishex
  pop cx
  jc %%bye
  push cx
  call asc2hex
  pop cx
%%adjust:
  push ax
  push cx
  mov cl,4
%%shift:
  rcl w[ofs],1
  rcl w[ofs+2],1
  loop %%shift
  pop cx
%%add:
  pop ax
  xor ah,ah
  add w[ofs],ax
  adc w[ofs+2],byte 0
%%continue:
  loop %%load
%%bye:
%endm

; --------------------------------------------------------------------
; section .text
org 100h
Main:
  charargs
  fixargs
  cmp b[ARGC],MINARGC
  jae .okay
  mov ah,WRITESTR
  mov dx,usagemsg
  DOS
  neg b[errlvl]
  jmp short Fino
.okay:
  mov si,ARGV+1
  scanofs
  jc Fino
  call fixbyte
Fino:
  mov ax,w[errlvl]
  DOS
; end Main
; --------------------------------------------------------------------


proc fixbyte
  cmp b[BYTE1],'?'
  jz .open
  call getbytes
  jc .ret
.issame:
  mov al,[oldbyte]
  cmp al,[newbyte]
  jz .ret
.open:
  mov ax,OPENFILERW
  mov dx,FILENAME
  DOS
  jc .ret
  mov [handle],ax
.seek:
  call seekbyte
  jc .close
.read:
  mov ah,READFILE
  mov bx,[handle]
  mov cx,1
  mov dx,foundbyte
  DOS
  jc .close
.query:
  cmp b[BYTE1],'?'
  jnz .compare
  mov al,[foundbyte]
  mov [errlvl],al
  jmp short .close
.compare:
  cmp b[BYTE1],'!'
  jz .seekagain
.noforce:
  mov al,[foundbyte]
  cmp al,[oldbyte]
  jnz .close
.seekagain:
  call seekbyte
.write:
  mov ah,WRITEFILE
  mov bx,[handle]
  mov cx,1
  mov dx,newbyte
  DOS
  jc .close
  dec b[errlvl]
.close:
  mov ah,CLOSEFILE
  mov bx,[handle]
  DOS
endp


proc seekbyte
  mov ax,SEEKSETFILE
  mov bx,[handle]
  mov cx,w[ofs+2]
  mov dx,w[ofs]
  DOS
endp


proc getbytes
  push ax
  mov di,oldbyte
  push di
  mov ax,[charbyte1]
  mov cx,[charbyte2]
  xchg al,ch
  cmp cx,"''"
  jnz .hex
  mov cx,2
.check:
  xchg ah,al
  mov dx,'!~'
  push dx
  call rangecheck
  jc .bye
  loop .check
  xchg ah,al
  stosw
  jmp short .bye
.hex:
  mov si,BYTE1
  cmp b[si],'!'
  jnz .noforce
  add si,byte 3
  inc di
  jmp short .byte2
.noforce:
  call hexbyte
  jc .bye
.byte2:
  call hexbyte ; newbyte
.bye:
  pop di
  pop ax
endp


proc hexbyte
  lodsb
  call ishex
  jc .ret
  call asc2hex
  mov cl,4
  shl al,cl
  mov dl,al
  lodsb
  push dx
  call ishex
  pop dx
  jc .ret
  call asc2hex
  add dl,al
  inc si
  xchg ax,dx
  stosb
endp


proc asc2hex
  cmp al,40h
  adc al,69h
  daa
  mov ah,al
  and al,15
  mov cl,4
  shr ah,cl
  aad
endp


proc ishex
  mov cx,'09'
  push cx
  call rangecheck
  sbb bh,bh

; mov cx,'af'
; push cx
; call rangecheck
; sbb bl,bl
; and bh,bl

  mov cx,'AF'
  push cx
  call rangecheck
  sbb bl,bl
  and bh,bl

  shr bh,1  ; return CF if not valid hex char
endp


proc rangecheck
            ; in: (upper_limit shl 8) + lower_limit
  pop bp
  pop dx    ; mov dx,[sp+2]
  push bp
.check:
  cmp al,dl
  sbb ch,ch
  inc dh
  cmp al,dh
  cmc
  sbb dl,dl
  or dl,ch
  cmp dl,1  ; set CF if DL == 0
  cmc       ; return NC if AL within valid range
endp


; --------------------------------------------------------------------
section .data align=1
errlvl db 1, GOODBYE
ofs dd 0
usagemsg db CR,LF,'Usage: BYTEFIX CaFe5150 Ed A1 my.dat',CR,LF,'$'
; --------------------------------------------------------------------


; --------------------------------------------------------------------
section .bss align=1
oldbyte resb 1
newbyte resb 1
foundbyte resb 1
charbyte1 resw 1
charbyte2 resw 1
handle resw 1
; --------------------------------------------------------------------

; EOF
